//-----------------------------------------
// LoadLoaclRot -- LScript Genetic
// Noboru Fujiyama 2003/05/27
//  Load lrt file 
//  Only that whose name corresponds is adapted.
//parameter 
//  Load Local Rot file : load file name 
@version 2.5
@script generic
@name ATLoadLoaclRotZ 

@define AUTOMATON_VER 2.0

// BASE Libray select/key/channel
@insert "C:/tools/LWPlugin/NoboUtility/AutomatonZ/src/lscript/ATLib.lsi"

@define LAST_DIR "LastDir_Pose"

s_ItemNum;
s_asPanelItemNames;
s_asItemNames;
s_avRots;
s_avTrans;
a_anOutputFlag ;

s_nValueChk;
s_nIKChk;

s_IKMode = false ;


/* Node ViewOn/Off Flag */
s_nFingerFlg = 1 ;
s_nUpperFlg = 1 ;
s_nLowerFlg = 1 ;
s_nCtrlFlg=1;

s_xParentItem ;
/*************** Item Name Table ********************/
@insert "C:/tools/LWPlugin/NoboUtility/AutomatonZ/src/lscript/MBNameTable.lsi"
/*************** Item Name Table ********************/

generic 
{
	curScene = Scene();
	xSelected = curScene.firstSelect();	
	if(xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}
	push_selected_item( curScene , xSelected );
	
	s_nValueChk = 2 ;
	s_nIKChk = 2 ;
	s_nSymmetry = 2 ;
	


	reqbegin("Load Local Rot " + AUTOMATON_VER );
    reqsize(314,158);
    //
    var lastDir = globalrecall(LAST_DIR,"");
    var scenesDir = getdir("Scenes");
    var contentDir = getdir("Content");
    var dir = "";
    if( fileexists(lastDir) )
    {
        dir = lastDir;
    }
    else if( fileexists(scenesDir) )
    {
        dir = scenesDir;
	}
    else if( fileexists( contentDir ) )
    {
        dir = contentDir;
    }

	c1 = ctlfilename("Load Local Rot file",dir, 30 , 1 );

//    c2 = ctlchoice("Check Value",s_nValueChk,@"Yes","No"@);

//    c3 = ctlchoice("Load IK control",s_nIKChk,@"Yes","No"@);

    c4 = ctlchoice("symmetry",s_nSymmetry,@"Yes","No"@);

    return if !reqpost();

	fileName = getvalue(c1);
//	s_nValueChk = getvalue(c2);
//	s_nIKChk = getvalue(c3);
	s_nSymmetry = getvalue(c4);

    reqend();

	path = split(fileName);

@if platform == INTEL
	globalstore( LAST_DIR , path[1]+path[2] );
@end
	
	if((textFile = File(fileName)) == nil)
	{
		error("Could not open file ", fileName );
		return;		
	} 

	line = nil;
	s_ItemNum=1 ;
	while( textFile.eof() != true)
	{
		line = textFile.read();
		items = parse(":",line);
		if( items.count() > 1 )
		{
			if( 3 > items.count() )
			{
				s_asItemNames[s_ItemNum] = items[1] ;
				s_asPanelItemNames[s_ItemNum] = "*:" +  items[1] ;
				s_avRots[s_ItemNum] = vector( items[2] ) ;
				s_avTrans[s_ItemNum] = nil ;
				s_ItemNum++ ;
			}
			else {
				s_IKMode = true ;
				s_asItemNames[s_ItemNum] = items[1] ;
				s_asPanelItemNames[s_ItemNum] = "*:" + items[1] ;
				s_avRots[s_ItemNum] = vector( items[5] ) ;
				s_avTrans[s_ItemNum] = vector( items[3] ) ;
				s_ItemNum++ ;
			}
		}
	}

	s_nFingerFlg = on_off_mng( 1 , s_asFingerRot );

	//if( true == s_IKMode )
	{
		while( nil != xSelected.parent )
		{
			xSelected = xSelected.parent ;
		}		
		select_by_name( xSelected , "Master" );
		xSelected = s_xSearchItem;
	}
	s_nValueChk = false ;
	reqbegin("ATPastePose " + AUTOMATON_VER );
	ctllistbox("Load Bone Items" , 300 , 300 , "lb_count","lb_name","lb_event");
    //ctlposition(c1,10,310 );	
    //ctlposition(c2,10+62 ,310 );	
    //ctlposition(c3,10+62+62 ,310 );	
    //ctlposition(c4,10+62+62+62 ,310 );	
	return if !reqpost();

	reqend();
	// OutputFlag Setting 
	for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
	{
		lines = parse(":", s_asPanelItemNames[ nLoop ]);
		if( "*" == lines[1] )
		{
			a_anOutputFlag[ nLoop ] = 1 ;
		}
		else {
			a_anOutputFlag[ nLoop ] = 0 ;
		}
		s_asPanelItemNames[ nLoop ] = lines[2];
	}
	nTime = curScene.currenttime ;
	SymmetryNameToId(xSelected,nTime,s_nSymmetry);
	
	RefreshNow();
}

cheak_item_output : nSymmetryFlag , name 
{
	if( -1 == nSymmetryFlag )
	{
		for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
		{
			if( name == s_asPanelItemNames[ nLoop ] )
			{
				return a_anOutputFlag[ nLoop ];
			}
		}
	}
	else {
		return a_anOutputFlag[ nSymmetryFlag ];
	}
	return 0 ;
}

SymmetryNameToId : rootObj,time , nSymmetry
{
	for( no = 1 ; no < s_ItemNum ; no++ )
	{
		vRot = <0,0,0>;
		vRot = s_avRots[no] ;
		sName = s_asItemNames[no] ;
		nSymmetryFlag = no ;
		if( 1 == nSymmetry )
		{
			sTempName = s_asItemNames[no]  ;
			sPre = strleft( s_asItemNames[no] , 2 );

			sPre1 = strleft( s_asItemNames[no] , 5 );
			sPre2 = strleft( s_asItemNames[no] , 4 );
			if( sPre1 == "Right" )
			{
				sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 5 ); 
				sName = "Left" + sTemp ;
				nSymmetryFlag = -1 ;
			}
			else if( sPre2 == "Left" ) 
			{
				sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 4 ); 
				sName = "Right" + sTemp  ;
				nSymmetryFlag = -1 ;
			}
			if( "HipsSpin" != sTempName )
			{
				fX = -1 * s_avRots[no].x ; 
				fZ = -1 * s_avRots[no].z ; 
				vRot = <fX,vRot.y,fZ>;
			}
			else {
				fX = 180.0 - ( s_avRots[no].x - 180.0 ) ; 
				fZ = -1 * s_avRots[no].z ; 
				vRot = <fX,vRot.y,fZ>;
			}
		}
		//if( 1 == cheak_item_output( nSymmetryFlag , sName ) )
		{ 
			xName = parse( " (" , rootObj.name ) ;
			if( xName[ 1 ] == sName )
			{
				if( nil != s_avTrans[no] && s_nIKChk == 1 )
				{
					createKeys( rootObj , nil , vRot , nil , time );
					vTrans = s_avTrans[no] ;
					if( 1 == nSymmetry )
					{
						fX = -1 * s_avTrans[no].x ; 
						vTrans = <fX,vTrans.y,vTrans.z>;					
					}
					createKeys( rootObj , vTrans , nil , nil ,time );
				}
				else if( nil == s_avTrans[no] )
				{
					createKeys( rootObj , nil , vRot , nil , time );
				}
			}
		}
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		SymmetryNameToId(childObj,time,nSymmetry);
		childObj = rootObj.nextChild();
	}
}

// Node View CallBack
button_callback_c1 
{
	s_nFingerFlg = on_off_mng( s_nFingerFlg , s_asFingerRot );
	requpdate() ;	
}

button_callback_c2
{
	s_nUpperFlg = on_off_mng( s_nUpperFlg , get_upper_name() );
	requpdate() ;	
}

button_callback_c3 
{
	s_nLowerFlg = on_off_mng( s_nLowerFlg , get_lower_name() );
	requpdate() ;	
}
button_callback_c4 
{
	s_nCtrlFlg = on_off_mng( s_nCtrlFlg , get_trans_and_rotaion_name() );
	requpdate() ;	
}
on_off_mng : nFlag , sNameArry
{
	for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
	{
		lines = parse(":",s_asPanelItemNames[nLoop]);
		xName = parse( " (" , lines[2] ) ;
		if( check_include( xName[1] , sNameArry ) )
		{
			if( nFlag )
			{
				s_asPanelItemNames[nLoop] = "*:" + lines[2] ;
			}
			else {
				s_asPanelItemNames[nLoop] = " :" + lines[2] ;
			}
		}
	}
	if( 0 == nFlag ) nFlag = 1 ;
	else nFlag = 0 ;
	return  nFlag ;
}

check_include : sName , asNameArray 
{

	for( nLoop = 1 ; nLoop <= asNameArray.size() ; nLoop++ )
	{
		if( asNameArray[ nLoop ] == sName ) return  true ; 
	}
	return  false ;
}


lb_count
{
     return(s_asPanelItemNames.size());
}

lb_name: index
{
     return(s_asPanelItemNames[index]);
}

lb_event: items
{
	if(items != nil)
	{
		for( nLoop = 1 ; nLoop <= items.size() ; nLoop++ )
		{
			nIndex = items[ nLoop ];
			lines = parse(":",s_asPanelItemNames[nIndex]);
			if( "*" == lines[1] )
			{
				s_asPanelItemNames[nIndex] = " :" + lines[2] ;
			}
			else {
				s_asPanelItemNames[nIndex] = "*:" + lines[2] ;
			}
		}
		requpdate() ;
	}
}
