//-----------------------------------------
// ATPastePoseAdv -- LScript Genetic
// Noboru Fujiyama 2003/05/27
//                 2003/09/25  add Automaton Model
//  Load lrt file 
//parameter 
//  Load Local Rot file : load file name 
@script generic
@name ATPastePoseAdvZ

@define AUTOMATON_VER 2.5
@define LAST_NAM   "PoseAdvLastNum"
@define LAST_LOOP  "PoseAdvLastLoop"
@define LAST_CYCLE "PoseAdvLastCycle"

s_ItemNum;
s_asPanelItemNames;
s_asItemNames;
s_avRots;
s_avTrans;
a_anOutputFlag ;

s_nValueChk;
s_nIKChk;

s_IKMode = false ;

/* Node ViewOn/Off Flag */
s_nFingerFlg = 0 ;
s_nUpperFlg = 1 ;
s_nLowerFlg = 1 ;
s_nCtrlFlg=1;

// BASE Libray select/key/channel
@insert "C:/tools/LWPlugin/NoboUtility/AutomatonZ/src/lscript/ATLib.lsi"


/*************** Item Name Table ********************/
@insert "C:/tools/LWPlugin/NoboUtility/AutomatonZ/src/lscript/MBNameTable.lsi"

generic 
{
	curScene = Scene();
	s_nIKChk = 1 ;

	xSelected = curScene.firstSelect();
	if( xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}	
	push_selected_item( curScene , xSelected );
	if( 0 == ( nItemType = check_item( s_xParentItem , get_trans_and_rotaion_name() , 14 ) ) )
	{
		error("<br>You must select Automaton character Item ." );
		return;		
	}
		
	fileName = get_temp_filename() ;

	if((textFile = File(fileName)) == nil)
	{
		error("Could not open file ", fileName );
		return;		
	} 

	
    var s_nNum  = recall( LAST_NAM   , 1  );
    var s_nLoop = recall( LAST_LOOP  , 1 );
    var s_nWalkCycle = recall( LAST_CYCLE , false );

    reqbegin("ATPastePoseAdv "  + AUTOMATON_VER );
    reqsize(257,171);

    c1 = ctlinteger("Repeats",s_nNum);
    ctlposition(c1,12,41);

    c2 = ctlinteger("Cycle Gap",s_nLoop);
    ctlposition(c2,12,12);

    c3 = ctlcheckbox("WalkCycle",s_nWalkCycle);
    ctlposition(c3,22,110);

    return if !reqpost();

    s_nNum = getvalue(c1);
    s_nLoop = getvalue(c2);
    s_nWalkCycle = getvalue(c3);

    reqend();
	
	store( LAST_NAM , s_nNum );
	store( LAST_LOOP , s_nLoop );
	store( LAST_CYCLE , s_nWalkCycle );
	
	
	fileName = get_temp_filename() ;
	
	if((textFile = File(fileName)) == nil)
	{
		error("Could not open file ", fileName );
		return;		
	} 

	line = nil;
	s_ItemNum=1 ;
	while( textFile.eof() != true)
	{
		line = textFile.read();
		items = parse(":",line);
		if( items.count() > 1 )
		{
			if( 3 > items.count() )
			{
				s_asItemNames[s_ItemNum] = items[1] ;
				s_asPanelItemNames[s_ItemNum] = "*:" +  items[1] ;
				s_avRots[s_ItemNum] = vector( items[2] ) ;
				s_avTrans[s_ItemNum] = nil ;
				s_ItemNum++ ;
			}
			else {
				s_IKMode = true ;
				s_asItemNames[s_ItemNum] = items[1] ;
				s_asPanelItemNames[s_ItemNum] = "*:" + items[1] ;
				s_avRots[s_ItemNum] = vector( items[5] ) ;
				s_avTrans[s_ItemNum] = vector( items[3] ) ;
				s_ItemNum++ ;
			}
		}
	}

	s_nFingerFlg = on_off_mng( s_nFingerFlg , s_asFingerRot );

	if( true == s_IKMode )
	{
		while( nil != xSelected.parent )
		{
			xSelected = xSelected.parent ;
		}		
		select_by_name( xSelected , "Master" );
		xSelected = s_xSearchItem;
	}
	s_nValueChk = false ;
	reqbegin("ATPastePose " + AUTOMATON_VER );
	ctllistbox("Load Bone Items" , 300 , 300 , "lb_count","lb_name","lb_event");
	c1 = ctlbutton( "Finger", 60 , "button_callback_c1" );
	c2 = ctlbutton( "Upper" , 60 , "button_callback_c2" );
   	c3 = ctlbutton( "Lower" , 60 , "button_callback_c3" );
   	c4 = ctlbutton( "Ctrl"  , 60 , "button_callback_c4" );
    ctlposition(c1,10,310 );	
    ctlposition(c2,10+62 ,310 );	
    ctlposition(c3,10+62+62 ,310 );	
    ctlposition(c4,10+62+62+62 ,310 );	
	return if !reqpost();

	reqend();

	// OutputFlag Setting 
	for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
	{
		lines = parse(":", s_asPanelItemNames[ nLoop ]);
		if( "*" == lines[1] )
		{
			a_anOutputFlag[ nLoop ] = 1 ;
		}
		else {
			a_anOutputFlag[ nLoop ] = 0 ;
		}
		s_asPanelItemNames[ nLoop ] = lines[2];
	}

	// Create Key 
	nTime = curScene.currenttime ;
	s_nLoop = s_nLoop / curScene.fps ;

	for( nLoop = 1 ; nLoop <= s_nNum ; nLoop++ )
	{
		nTime  = nTime + s_nLoop ;
		nSymmetryFlag = ( nLoop % 2 ) ;
		if( s_nWalkCycle == 1 )
		{
			SymmetryNameToId(xSelected,nTime,nSymmetryFlag);
		}
		else {
			SymmetryNameToId(xSelected,nTime,0);
		}
	}
	
	RefreshNow();
}
cheak_item_output : nSymmetryFlag , name 
{
	if( -1 == nSymmetryFlag )
	{
		for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
		{
			if( name == s_asPanelItemNames[ nLoop ] )
			{
				return a_anOutputFlag[ nLoop ];
			}
		}
	}
	else {
		return a_anOutputFlag[ nSymmetryFlag ];
	}
	return 0 ;
}

SymmetryNameToId : rootObj,time , nSymmetry
{
	for( no = 1 ; no < s_ItemNum ; no++ )
	{
		vRot = <0,0,0>;
		vRot = s_avRots[no] ;
		sName = s_asItemNames[no] ;
		nSymmetryFlag = no ;
		if( 1 == nSymmetry )
		{
			sTempName = s_asItemNames[no]  ;
			sPre = strleft( s_asItemNames[no] , 2 );

			sPre1 = strleft( s_asItemNames[no] , 5 );
			sPre2 = strleft( s_asItemNames[no] , 4 );
			if( sPre1 == "Right" )
			{
				sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 5 ); 
				sName = "Left" + sTemp ;
				nSymmetryFlag = -1 ;
			}
			else if( sPre2 == "Left" ) 
			{
				sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 4 ); 
				sName = "Right" + sTemp  ;
				nSymmetryFlag = -1 ;
			}
			if( "HipsSpin" != sTempName )
			{
				fX = -1 * s_avRots[no].x ; 
				fZ = -1 * s_avRots[no].z ; 
				vRot = <fX,vRot.y,fZ>;
			}
			else {
				fX = 180.0 - ( s_avRots[no].x - 180.0 ) ; 
				fZ = -1 * s_avRots[no].z ; 
				vRot = <fX,vRot.y,fZ>;
			}
		}
		if( 1 == cheak_item_output( nSymmetryFlag , sName ) )
		{ 
			xName = parse( " (" , rootObj.name ) ;
			if( xName[ 1 ] == sName )
			{
				if( nil != s_avTrans[no] && s_nIKChk == 1 )
				{
					createKeys( rootObj , nil , vRot , nil , time );
					vTrans = s_avTrans[no] ;
					if( 1 == nSymmetry )
					{
						fX = -1 * s_avTrans[no].x ; 
						vTrans = <fX,vTrans.y,vTrans.z>;					
					}
					createKeys( rootObj , vTrans , nil , nil ,time );
				}
				else if( nil == s_avTrans[no] )
				{
					createKeys( rootObj , nil , vRot , nil , time );
				}
			}
		}
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		SymmetryNameToId(childObj,time,nSymmetry);
		childObj = rootObj.nextChild();
	}
}

// Node View CallBack
button_callback_c1 
{
	s_nFingerFlg = on_off_mng( s_nFingerFlg , s_asFingerRot );
	requpdate() ;	
}

button_callback_c2
{
	s_nUpperFlg = on_off_mng( s_nUpperFlg , get_upper_name() );
	requpdate() ;	
}

button_callback_c3 
{
	s_nLowerFlg = on_off_mng( s_nLowerFlg , get_lower_name() );
	requpdate() ;	
}
button_callback_c4 
{
	s_nCtrlFlg = on_off_mng( s_nCtrlFlg , get_trans_and_rotaion_name() );
	requpdate() ;	
}
on_off_mng : nFlag , sNameArry
{
	for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
	{
		lines = parse(":",s_asPanelItemNames[nLoop]);
		xName = parse( " (" , lines[2] ) ;
		if( check_include( xName[1] , sNameArry ) )
		{
			if( nFlag )
			{
				s_asPanelItemNames[nLoop] = "*:" + lines[2] ;
			}
			else {
				s_asPanelItemNames[nLoop] = " :" + lines[2] ;
			}
		}
	}
	if( 0 == nFlag ) nFlag = 1 ;
	else nFlag = 0 ;
	return  nFlag ;
}

check_include : sName , asNameArray 
{

	for( nLoop = 1 ; nLoop <= asNameArray.size() ; nLoop++ )
	{
		if( asNameArray[ nLoop ] == sName ) return  true ; 
	}
	return  false ;
}


lb_count
{
     return(s_asPanelItemNames.size());
}

lb_name: index
{
     return(s_asPanelItemNames[index]);
}

lb_event: items
{
	if(items != nil)
	{
		for( nLoop = 1 ; nLoop <= items.size() ; nLoop++ )
		{
			nIndex = items[ nLoop ];
			lines = parse(":",s_asPanelItemNames[nIndex]);
			if( "*" == lines[1] )
			{
				s_asPanelItemNames[nIndex] = " :" + lines[2] ;
			}
			else {
				s_asPanelItemNames[nIndex] = "*:" + lines[2] ;
			}
		}
		requpdate() ;
	}
}
