// LW95
@version 2.6
@warnings
@script generic
@name AutomatonZ 


// BASE Libray select/key/channel
@insert "ATLib.lsi"
// AT*** function
@insert "NCommon2.lsi"
//ATIK_*** function
@insert "GenerateIK2.lsi"

var AUTOMATON_Z_VER ="2.2";

var sLArm = @"LeftShoulder_a" ,"LeftShoulderBase" ,"LeftShoulder" ,"LeftShoulderIKBase" ,"LeftShoulder2_IKNull","LeftArm","LeftForeArm","LeftHand"@;
var sLArmNoActive = @"LeftShoulder_a","LeftShoulderIKBase","LeftShoulder2_IKNull","LeftHand","LeftHandDir"@;
var sLArmLock = @"LeftShoulder_a" ,"LeftShoulderIKBase" ,"LeftShoulder2_IKNull"@;

var sRArm = @"RightShoulder_a" ,"RightShoulderBase" ,"RightShoulder" ,"RightShoulderIKBase" ,"RightShoulder2_IKNull","RightArm","RightForeArm","RightHand"@;
var sRArmNoActive = @"RightShoulder_a","RightShoulderIKBase","RightShoulder2_IKNull","RightHand","RightHandDir"@;
var sRArmLock = @"RightShoulder_a" ,"RightShoulderIKBase" ,"RightShoulder2_IKNull"@;

var sLLeg = @"LeftHip_a" ,"LeftHip" ,"LeftHipIKBase" , "LeftHip2_IKNull", "LeftUpLeg", "LeftLeg", "LeftAnkEff", "LeftFootDir", "LeftFoot", "LeftToeBase"@; 
var sLLegNoActive = @"LeftHip_a","LeftHipIKBase" , "LeftHip2_IKNull", "LeftAnkleEff","LeftFootDir","LeftFootDirEff", "LeftToeEff"@; 
var sLLegLock = @"LeftHip_a" , "LeftHipIKBase", "LeftHip2_IKNull" , "LeftAnkleEff","LeftToeEff"@; 

var sRLeg = @"RightHip_a" ,"RightHip" ,"RightHipIKBase" , "RightHip2_IKNull", "RightUpLeg", "RightLeg", "RightAnkEff", "RightFootDir", "RightFoot", "RightToeBase"@; 
var sRLegNoActive = @"RightHip_a","RightHipIKBase" , "RightHip2_IKNull", "RightAnkleEff","RightFootDir","RightFootDirEff", "RightToeEff"@; 
var sRLegLock = @"RightHip_a" , "RightHipIKBase", "RightHip2_IKNull" , "RightAnkleEff","RightToeEff"@; 


var s_fHeadMove =1.0 ;
generic 
{

	var nGenerateSubBone = 0 ;
	var nGenerateNee = 0 ;
	
	var dLArmStretch = 0 ;
	var dRArmStretch = 0 ;
	var dLLegStretch = 0 ;
	var dRLegStretch = 0 ;
    nUseWaightMap = globalrecall( "AutomatonUseWaightMap" ) ;
    nUpVectorMode = globalrecall( "AutomatonUpVectorMode" ) ;
    if( nil == nUseWaightMap )
    {
		nUseWaightMap = 1 ;
	}
	else {
		nUseWaightMap = integer( nUseWaightMap );
	}
    if( nil == nUpVectorMode )
    {
		nUpVectorMode = 1 ;
	}
	else {
		nUpVectorMode = integer( nUpVectorMode );
	}	
	nY = 5 ;
	reqbegin("AutomatonZ Commander " + AUTOMATON_Z_VER  );
	reqsize(410,260);
	c1 = ctlcheckbox("Generate Sub Bone ",nGenerateSubBone);
    ctlposition(c1,5,nY , 200 );					nY+=24 ;
	c2 = ctlcheckbox("Generate Nee " ,nGenerateNee);
	ctlposition(c2,5,nY ,200);					nY+=24 ;
    c3 = ctlnumber(  "LArmStretch " , dLArmStretch );
	ctlposition(c3,5,nY ,200);					nY+=24 ;
	c4 = ctlnumber("RArmStretch  ", dRArmStretch);
    ctlposition(c4,5,nY ,200);					nY+=24 ;
    c5 = ctlnumber(  "LLegStretch " , dLLegStretch );
	ctlposition(c5,5,nY ,200);					nY+=24 ;
	c6 = ctlnumber("RLegStretch  ", dRLegStretch);
    ctlposition(c6,5,nY ,200);					nY+=24 ;
    
   	c7 = ctlchoice("WeightMap",nUseWaightMap,@"Not Use","Skelegon"@);
    ctlposition(c7,5,nY ,300);					nY+=24 ;

   	c8 = ctlchoice("UpVector",nUpVectorMode,@"Full Mode","Simple Mode"@);
    ctlposition(c8,5,nY ,300);					nY+=24 ;
	
    if( !reqpost() )
    {
		return 0 ;
	}
	
	nGenerateSubBone = getvalue(c1);
	nGenerateNee = getvalue(c2);
	dLArmStretch = getvalue(c3);
	dRArmStretch = getvalue(c4);
	dLLegStretch = getvalue(c5);
	dRLegStretch = getvalue(c6);
	nUseWaightMap = getvalue(c7);
	nUpVectorMode = getvalue(c8);
@if platform == INTEL
	globalstore( "AutomatonUseWaightMap" , nUseWaightMap );
	globalstore( "AutomatonUpVectorMode" , nUpVectorMode );
@end

	
	var xGlobalTime  = 0 ;
	CommandInput( "SkelegonsToBones" ) ;

	ATStart();
	CommandInput( "EnableIK" ) ;
	xScene = Scene();	
	xModel = xScene.firstSelect();
	GoToFrame( 0 );
	/// Move rest Pos 
	vPos = <0,0,0> ;
	vRot = <0,0,0> ;
	createKeys( xModel , vPos , vRot , nil , 0 );
	
	if(xModel == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}
	xRoot = ATGetRootItem() ;

	xMaster = ATAddNullSnaped( xRoot , "___TEMP_Master" , xGlobalTime );
	CommandInput( "Rename Master" ) ;
	ATInplaceParent( xMaster , xRoot );	
	SelectItem( xMaster.id ); 

	ATSetCustomShape( xMaster , 6 , 1.0 , 1 , nil);
	ATSetSchematicPosition( xModel , 0 , -8.0 , 1 );
	SelectItem( xModel.id );
	ATSetSchematicPosition( xMaster , 0 ,  8.0 , 11 );

	xBlendCtrBase = ATAddNullSnaped( xRoot , "___TEMP_ControlBase" , xGlobalTime );
	CommandInput( "Rename BlendCtrBase" ) ;
	ATInplaceParent( xMaster , xBlendCtrBase );	
	SelectItem( xBlendCtrBase.id );
	ATSetSchematicPosition( xMaster , 0 ,  6.0 , 11 );
	
	xRootBone = select_by_name( xRoot , "Hips" );
	xSpine = select_by_name( xRoot , "Spine" );
	ATInplaceParent( xRootBone , xSpine );
	xRootSpin = select_by_name( xRoot , "RootSpin" );
	ATInplaceParent( xRootBone , xRootSpin );
	
	xHeadBone = select_by_name(  xRoot  , "QuadHead" ) ;
	BodySchematic( xRoot , xModel , xHeadBone );

	if( null != ATIK_Leg_Start( xRoot , "LeftAnkleEff" , "LeftUpLeg" , "LeftFootDirEff" , "LeftToeBase" ,"LeftToeEff" ) )
	{
		vStartRot = <180,0,90> ;
		ATIK_GenerateIKBaseBone( "LeftHipIKBase" , "LeftHip" , vStartRot );
		ATIK_Leg_GenerateIKControlNULL( OFFSET_X_AXIS , 1 );
		ATIK_IKControlSetting( xMaster , "LeftFtAnkleGoal" , "LeftLegUPVector" , AXIS_HEADINMG , dLLegStretch );
		ATIK_GenerateTargetBone( "LeftLeg_Target", "LeftHip2_IKNull", "LeftLeg_IKFKBlendCtr" );
		ATIK_Leg_ReverceFootIKSetting( xMaster , "LeftFtCtrl" , "LeftFtRot" , "LeftFtGoal"  , "LeftFtTipGoal" );
		ATIK_Schematic( "LeftHip" , 10 , 3  , ATIK_SCHEMATIC_PLUS );
		BonesSetup( xRoot , sLLeg ,  sLLegNoActive , sLLegLock , nUseWaightMap );
		FootSchematic( xMaster , "LeftAnkleEff" , ATIK_SCHEMATIC_PLUS );
		ATRotaionEnavble( xRoot , "LeftLeg" , RotaionEnavbleH );
		
		ATIK_End() ;
	}
	UpdateMotion();	
 	if( null != ATIK_Leg_Start( xRoot , "RightAnkleEff" , "RightUpLeg" , "RightFootDirEff" , "RightToeBase" ,"RightToeEff" ) )
	{
		vStartRot = <180,0,-90> ;
		ATIK_GenerateIKBaseBone( "RightHipIKBase" , "RightHip" , vStartRot );
		ATIK_Leg_GenerateIKControlNULL( OFFSET_X_AXIS_MINUS , 1 );
		ATIK_IKControlSetting( xMaster , "RightFtAnkleGoal" , "RightLegUPVector" , AXIS_HEADINMG , dRLegStretch );
		ATIK_GenerateTargetBone( "RightLeg_Target", "RightHip2_IKNull", "RightLeg_IKFKBlendCtr" );
		ATIK_Leg_ReverceFootIKSetting( xMaster , "RightFtCtrl" , "RightFtRot" , "RightFtGoal"  , "RightFtTipGoal" );
		ATIK_Schematic( "RightHip" , 12 , 5  , ATIK_SCHEMATIC_MINUS );
		BonesSetup( xRoot , sRLeg ,  sRLegNoActive , sRLegLock , nUseWaightMap );
		FootSchematic( xMaster , "RightAnkleEff" , ATIK_SCHEMATIC_MINUS );
		ATRotaionEnavble( xRoot , "RightLeg" , RotaionEnavbleH );
		
		ATIK_End() ;
	}
	UpdateMotion();	
	// Sertch HeadName 
	if( xHeadBone == null )
	{
		// HumanMode
		if( null != ATIK_Start( xRoot , "LeftHand" , "LeftArm" ) )
		{
			vStartRot =<0,0,-90> ;
			ATIK_GenerateIKBaseBone( "LeftShoulderIKBase" , "LeftShoulder" , vStartRot );
			ATIK_GenerateIKControlNULL( OFFSET_Y_AXIS , 1 );
			ATIK_IKControlSetting( xMaster , "LeftArmGoal" , "LeftArmUPVector" , AXIS_PITCH , dLArmStretch );
			ATIK_GenerateTargetBone( "LeftArm_Target", "LeftShoulder2_IKNull", "LeftArm_IKFKBlendCtr" );
			ATRecPivRot( xRoot , "LeftArm"  );	
			BonesSetup( xRoot , sLArm ,  sLArmNoActive , sLArmLock , nUseWaightMap );
			ATIK_Schematic( "LeftShoulder" , 10 , 3  , ATIK_SCHEMATIC_PLUS );
			ATIK_Hand_DirectionControl( xMaster , "LeftArmGoal" , "LeftHandDirTarget" , "LeftHandDirUPVector" , ATIK_SCHEMATIC_PLUS );
			ATRotaionEnavble( xRoot , "LeftForeArm" , RotaionEnavbleP );
			
			ATIK_End() ;
		}
		UpdateMotion();	
		
		if( null != ATIK_Start( xRoot , "RightHand" , "RightArm" ) )
		{
			vStartRot =<0,0,-90> ;
			ATIK_GenerateIKBaseBone( "RightShoulderIKBase" , "RightShoulder" , vStartRot );
			ATIK_GenerateIKControlNULL( OFFSET_Y_AXIS , 1 );
			ATIK_IKControlSetting( xMaster , "RightArmGoal" , "RightArmUPVector" , AXIS_PITCH , dRArmStretch );
			ATIK_GenerateTargetBone( "RightArm_Target", "RightShoulder2_IKNull", "RightArm_IKFKBlendCtr" );
			ATRecPivRot( xRoot , "RightArm"  );	
			BonesSetup( xRoot , sRArm ,  sRArmNoActive , sRArmLock , nUseWaightMap );
			ATIK_Schematic( "RightShoulder" , 12 , 5  , ATIK_SCHEMATIC_MINUS );
			ATIK_Hand_DirectionControl( xMaster , "RightArmGoal" , "RightHandDirTarget" , "RightHandDirUPVector" ,  ATIK_SCHEMATIC_MINUS);
			ATRotaionEnavble( xRoot , "RightForeArm" , RotaionEnavbleP );
			
			ATIK_End();
		}
		UpdateMotion();	
		Finger( xMaster , "LeftHandDirTarget" , "RightHandDirTarget" , dLArmStretch  ,  dRArmStretch ) ;
		UpdateMotion();	
	}
	else {
		// QuadMode 
		if( null != ATIK_Leg_Start( xRoot , "LeftHandEff" , "LeftArm" , "LeftHandDirEff" , "LeftHandBase" ,"LeftHandBaseEff" ) )
		{
			vStartRot = <180,0,90> ;
			ATIK_GenerateIKBaseBone( "LeftShoulderIKBase" , "LeftShoulder" , vStartRot );
			ATIK_Leg_GenerateIKControlNULL( OFFSET_X_AXIS , 1 );
			ATIK_IKControlSetting( xMaster , "LeftArmEndGoal" , "LeftArmUPVector" , AXIS_HEADINMG , dLArmStretch );
			ATIK_GenerateTargetBone( "LeftArm_Target", "LeftShoulder2_IKNull", "LeftArm_IKFKBlendCtr" );
			ATIK_Leg_ReverceFootIKSetting( xMaster , "LeftArmGoal" , "LeftArmRot" , "LeftArmHandDirGoal"  , "LeftArmTipGoal" );
			ATIK_Schematic( "LeftShoulder" ,  10 , 3  , ATIK_SCHEMATIC_PLUS );
			BonesSetup( xRoot , sLArm ,  sLArmNoActive , sLArmLock , nUseWaightMap );
			QuadFrontFootSchematic( xMaster , "LeftHandEff" , ATIK_SCHEMATIC_PLUS );
			ATRotaionEnavble( xRoot , "LeftForeArm" , RotaionEnavbleH );
			
			ATIK_End() ;
		}
		if( null != ATIK_Leg_Start( xRoot , "RightHandEff" , "RightArm" , "RightHandDirEff" , "RightHandBase" ,"RightHandBaseEff" ) )
		{
			vStartRot = <180,0,-90> ;
			ATIK_GenerateIKBaseBone( "RightShoulderIKBase" , "RightShoulder" , vStartRot );
			ATIK_Leg_GenerateIKControlNULL( OFFSET_X_AXIS_MINUS , 1 );
			ATIK_IKControlSetting( xMaster , "RightArmEndGoal" , "RightArmUPVector" , AXIS_HEADINMG , dRArmStretch );
			ATIK_GenerateTargetBone( "RightArm_Target", "RightShoulder2_IKNull", "RightArm_IKFKBlendCtr" );
			ATIK_Leg_ReverceFootIKSetting( xMaster , "RightArmGoal" , "RightArmRot" , "RightArmHandDirGoal"  , "RightArmTipGoal" );
			ATIK_Schematic( "RightShoulder" ,  12 , 5   , ATIK_SCHEMATIC_MINUS );
			BonesSetup( xRoot , sRArm ,  sRArmNoActive , sRArmLock , nUseWaightMap );
			QuadFrontFootSchematic( xMaster , "RightHandEff" , ATIK_SCHEMATIC_MINUS );
			ATRotaionEnavble( xRoot , "RightForeArm" , RotaionEnavbleH );
		
			ATIK_End() ;
		}
		// Tail 
		vStartRot =<0,0,90> ;
		GenerateTail( xMaster , "Tail_IK","Tail_a" , vStartRot , nUseWaightMap );
	}
	// 

	var nSubdivideNum = 3 ;
	
	if( nGenerateSubBone == 1 ) GenerateTawasi( xRoot , nSubdivideNum , nUseWaightMap );
	if( nGenerateNee == 1 ) GenerateHiziHiza( xRoot , xHeadBone );

	CommandInput( "EnableIK" ) ;
	UpdateMotion();	
	// Group IKFKBlend Null 
	ATInplaceParentName( xMaster , "BlendCtrBase" , "RightArm_IKFKBlendCtr" );
	ATInplaceParentName( xMaster , "BlendCtrBase" , "LeftArm_IKFKBlendCtr" );
	ATInplaceParentName( xMaster , "BlendCtrBase" , "RightLeg_IKFKBlendCtr" );
	ATInplaceParentName( xMaster , "BlendCtrBase" , "LeftLeg_IKFKBlendCtr" );
	ATSchematic( xMaster , "RightArm_IKFKBlendCtr"    , xRootBone , -1.0 ,  1.0 , 1 );
	ATSchematic( xMaster , "LeftArm_IKFKBlendCtr"    , xRootBone ,   1.0 ,  1.0 , 1 );
	ATSchematic( xMaster , "RightLeg_IKFKBlendCtr"    , xRootBone , -1.0 , -3.0 , 1 );
	ATSchematic( xMaster , "LeftLeg_IKFKBlendCtr"    , xRootBone ,   1.0 , -3.0 , 1 );

	// bake tageting value  
	select_by_name( xRoot , "LeftArm_Target"  );
	CreateKey( 0 );
	select_by_name( xRoot , "LeftShoulder2_IKNull"  );
	CreateKey( 0 );
	select_by_name( xRoot , "RightArm_Target"  );
	CreateKey( 0 );
	select_by_name( xRoot , "RightShoulder2_IKNull"  );
	CreateKey( 0 );
	select_by_name( xRoot , "LeftLeg_Target"  );
	CreateKey( 0 );
	select_by_name( xRoot , "LeftHip2_IKNull"  );
	CreateKey( 0 );
	select_by_name( xRoot , "RightLeg_Target"  );
	CreateKey( 0 );
	select_by_name( xRoot , "RightHip2_IKNull"  );
	CreateKey( 0 );
	
	
	// Head
	GenerateHeadGoal( xMaster , "Head" );

	ReverceFootIK_FK( xMaster , xHeadBone ) ;

	ATRecordRestRotaionItem( xMaster , "HeadGoal" );

	// SimpleMode UpVector 
	if( nUpVectorMode == 2 )
	{
		xHips = select_by_name( xMaster , "Hips" );
		SimpleFootUpVector( xMaster , xHips ,"LeftFtCtrl", "LeftLegUPVector" ,  3 );
		SimpleFootUpVector( xMaster , xHips ,"RightFtCtrl","RightLegUPVector" , 5 );

		ATSetParent( xMaster ,"Spine3","LeftArmUPVector" , 1 );
		select_by_name( xMaster , "LeftArmUPVector") ;
		AddPosition( -s_fHeadMove*2 ,0 , 0 ) ;
		ATSetParent( xMaster ,"Spine3","RightArmUPVector" , 1 );
		select_by_name( xMaster , "RightArmUPVector") ;
		AddPosition( s_fHeadMove*2 ,0 , 0 );
		ATSetParent( xMaster ,"Spine3","LeftArmGoal" , 0 );
		ATSetParent( xMaster ,"Spine3","RightArmGoal" , 0 );
	}

	ATEnd( );
	
	// Null bone Setup
	null_bone_setup( xRoot , xRoot );	


}

SimpleFootUpVector : xMaster , xHips , sFootCtrl , sUpVector , color
{
	sHelper = sUpVector+"Helper";
	sTempHelper = "__Temp_"+sUpVector+"Helper";
	ATAddNull( sTempHelper  );
	ATParentAndRename( xMaster , sTempHelper  , sHelper ) ;
	xFoot = select_by_name( xMaster , sFootCtrl  );
	select_by_name( xMaster , sHelper ) ;
	CommandInput( "PositionItem " + hex( xHips.id ) );	
	CommandInput( "XController 6" );
	CommandInput( "YController 6" );
	CommandInput( "XController 6" );		
	CommandInput( "RotationItem " + hex( xFoot.id ) );	
	CommandInput( "HController 6" );
	CommandInput( "PController 0" );
	CommandInput( "BController 0" );		
	ATSetParent( xMaster ,sHelper , sUpVector , 1 );
	xUp = select_by_name( xMaster , sUpVector  );
	ATSchematic( xMaster , sHelper , xUp ,  0.0 , 0.5 , color );
	ATItemLock( xMaster , sHelper  );
}

// nWeightMapUse ->Not Use = 1 , Skelegon = 2
BonesSetup: xRoot , asRestPosition , asBoneActive , asItemLock , nWeightMapUse 
{
	for( i = 1 ; i<= asRestPosition.size() ; i++ )
	{
		ATBoneRecordRestPosition( xRoot , asRestPosition[ i ] );
	}
	for( i = 1 ; i<= asBoneActive.size() ; i++ )
	{	
		ATBoneActive( xRoot , asBoneActive[ i ] );
		if( nWeightMapUse == 1 )
		{
			sStr = "BoneWeightMapName (none) " ;
			CommandInput( sStr );
		}

	}
	UpdateMotion();	
	for( i = 1 ; i<= asItemLock.size() ; i++ )
	{
		ATItemLock( xRoot , asItemLock[ i ] );
	}
}

FootSchematic : xRoot , sSchematicOrgName , nType
{
	xSchematicOrgItem = select_by_name( xRoot , sSchematicOrgName );
	if( nType == ATIK_SCHEMATIC_PLUS )
	{
		cColor[ 1 ] = 10 ;
		cColor[ 2 ] = 3 ;
		nSign = nType ;
		ATSchematic( xRoot , "LeftFtCtrl"    , xSchematicOrgItem ,  nSign*0.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftFtRot"     , xSchematicOrgItem ,  nSign*1.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftFtTipGoal" , xSchematicOrgItem ,  nSign*2.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftFtGoal"    , xSchematicOrgItem ,  nSign*1.0 , -2.5 , cColor[ 2 ] );
		ATSchematic( xRoot , "LeftLegCtrl"   , xSchematicOrgItem ,  nSign*0.0 , -2.5 , cColor[ 2 ] );

		ATSchematic( xRoot , "LeftFootDir"    , xSchematicOrgItem ,  nSign*0.0 , -1.5 , cColor[ 2 ] );
		ATSchematic( xRoot , "LeftFootDirEff" , xSchematicOrgItem ,  nSign*0.0 , -2.0 , cColor[ 2 ] );
		ATSchematic( xRoot , "LeftFoot"       , xSchematicOrgItem ,  nSign*1.0 , -1.5 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftToeBase"    , xSchematicOrgItem ,  nSign*2.0 , -1.5 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftToeEff"     , xSchematicOrgItem ,  nSign*2.0 , -2.0 , cColor[ 2 ] );
		ATSchematic( xRoot , "LeftFtAnkleGoal", xSchematicOrgItem ,  nSign*1.0 , -0.5 , cColor[ 2 ] );

		ATItemLock( xRoot , "LeftFtGoal"      );
		ATItemLock( xRoot , "LeftLegCtrl"     );
		ATItemLock( xRoot , "LeftFootDir"     );
		ATItemLock( xRoot , "LeftFootDirEff"  );
		ATItemLock( xRoot , "LeftToeEff"      );
		ATItemLock( xRoot , "LeftFtAnkleGoal" );
		
	}
	else {
		cColor[ 1 ] = 12 ;
		cColor[ 2 ] = 5 ;
		nSign = nType ;
		ATSchematic( xRoot , "RightFtCtrl"     , xSchematicOrgItem ,  nSign*0.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightFtRot"      , xSchematicOrgItem ,  nSign*1.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightFtTipGoal"  , xSchematicOrgItem ,  nSign*2.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightFtGoal"     , xSchematicOrgItem ,  nSign*1.0 , -2.5 , cColor[ 2 ] );
		ATSchematic( xRoot , "RightLegCtrl"    , xSchematicOrgItem ,  nSign*0.0 , -2.5 , cColor[ 2 ] );

		ATSchematic( xRoot , "RightFootDir"    , xSchematicOrgItem ,  nSign*0.0 , -1.5 , cColor[ 2 ] );
		ATSchematic( xRoot , "RightFootDirEff" , xSchematicOrgItem ,  nSign*0.0 , -2.0 , cColor[ 2 ] );
		ATSchematic( xRoot , "RightFoot"       , xSchematicOrgItem ,  nSign*1.0 , -1.5 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightToeBase"    , xSchematicOrgItem ,  nSign*2.0 , -1.5 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightToeEff"     , xSchematicOrgItem ,  nSign*2.0 , -2.0 , cColor[ 2 ] );
		
		ATSchematic( xRoot , "RightFtAnkleGoal", xSchematicOrgItem ,  nSign*1.0 , -0.5 , cColor[ 2 ] );

		ATItemLock( xRoot , "RightFtGoal"      );
		ATItemLock( xRoot , "RightLegCtrl"     );
		ATItemLock( xRoot , "RightFootDir"     );
		ATItemLock( xRoot , "RightFootDirEff"  );
		ATItemLock( xRoot , "RightToeEff"      );
		ATItemLock( xRoot , "RightFtAnkleGoal" );
		
	}
}

ReverceFootIK_FK: xRoot , xHeadBone 
{
	xBoneName = "LeftFootDir" ;
	xBone = select_by_name( xRoot , xBoneName );
	CommandInput( "AddEnvelope IK.FKBlending" );	
	xLeftLeg_IKFKBlendCtr = select_by_name( xRoot , "LeftLeg_IKFKBlendCtr" );
	sExpName1 =   xLeftLeg_IKFKBlendCtr.name + "_FootIKFKBlend" ;
	sExpression1 = "clamp([" + xLeftLeg_IKFKBlendCtr.name+ ".Position.Z],0.000,1.000)" ;
	create_expression( sExpName1 , sExpression1 ) ;
	attach_expression( xRoot  ,  xBoneName , "IK.FKBlending"  , sExpName1 );		

	xBoneName = "RightFootDir" ;
	xBone = select_by_name( xRoot , xBoneName );
	CommandInput( "AddEnvelope IK.FKBlending" );	
	xLeftLeg_IKFKBlendCtr = select_by_name( xRoot , "RightLeg_IKFKBlendCtr" );
	sExpName1 =   xLeftLeg_IKFKBlendCtr.name + "_FootIKFKBlend" ;
	sExpression1 = "clamp([" + xLeftLeg_IKFKBlendCtr.name+ ".Position.Z],0.000,1.000)" ;
	create_expression( sExpName1 , sExpression1 ) ;
	attach_expression( xRoot  ,  xBoneName , "IK.FKBlending"  , sExpName1 );		
	if( xHeadBone != null )
	{
		xBoneName = "LeftHandDir" ;
		xBone = select_by_name( xRoot , xBoneName );
		CommandInput( "AddEnvelope IK.FKBlending" );	
		xLeftLeg_IKFKBlendCtr = select_by_name( xRoot , "LeftArm_IKFKBlendCtr" );
		sExpName1 =   xLeftLeg_IKFKBlendCtr.name + "_FootIKFKBlend" ;
		sExpression1 = "clamp([" + xLeftLeg_IKFKBlendCtr.name+ ".Position.Z],0.000,1.000)" ;
		create_expression( sExpName1 , sExpression1 ) ;
		attach_expression( xRoot  ,  xBoneName , "IK.FKBlending"  , sExpName1 );		

		xBoneName = "RightHandDir" ;
		xBone = select_by_name( xRoot , xBoneName );
		CommandInput( "AddEnvelope IK.FKBlending" );	
		xLeftLeg_IKFKBlendCtr = select_by_name( xRoot , "RightArm_IKFKBlendCtr" );
		sExpName1 =   xLeftLeg_IKFKBlendCtr.name + "_FootIKFKBlend" ;
		sExpression1 = "clamp([" + xLeftLeg_IKFKBlendCtr.name+ ".Position.Z],0.000,1.000)" ;
		create_expression( sExpName1 , sExpression1 ) ;
		attach_expression( xRoot  ,  xBoneName , "IK.FKBlending"  , sExpName1 );		
	
	}
}

QuadFrontFootSchematic : xRoot , sSchematicOrgName , nType
{
	xSchematicOrgItem = select_by_name( xRoot , sSchematicOrgName );
	if( nType == ATIK_SCHEMATIC_PLUS )
	{
		cColor[ 1 ] = 10 ;
		cColor[ 2 ] = 3 ;
		nSign = nType ;
		ATSchematic( xRoot , "LeftArmGoal"    , xSchematicOrgItem ,  nSign*0.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftArmRot"     , xSchematicOrgItem ,  nSign*1.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftArmTipGoal" , xSchematicOrgItem ,  nSign*2.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftArmHandDirGoal" , xSchematicOrgItem ,  nSign*1.0 , -2.5 , cColor[ 2 ] );
		ATSchematic( xRoot , "LeftArmEndGoal"  , xSchematicOrgItem ,  nSign*0.0 , -2.5 , cColor[ 2 ] );

		ATSchematic( xRoot , "LeftHandDir"    , xSchematicOrgItem ,  nSign*0.0 , -1.5 , cColor[ 2 ] );
		ATSchematic( xRoot , "LeftHandDirEff" , xSchematicOrgItem ,  nSign*0.0 , -2.0 , cColor[ 2 ] );
		ATSchematic( xRoot , "LeftHand"       , xSchematicOrgItem ,  nSign*1.0 , -1.5 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftHandBase"   , xSchematicOrgItem ,  nSign*2.0 , -1.5 , cColor[ 1 ] );
		ATSchematic( xRoot , "LeftHandBaseEff", xSchematicOrgItem ,  nSign*2.0 , -2.0 , cColor[ 2 ] );
		//ATSchematic( xRoot , "LeftArmGoal", xSchematicOrgItem ,  nSign*1.0 , -0.5 , cColor[ 2 ] );

		ATItemLock( xRoot , "LeftArmHandDirGoal"      );
		//ATItemLock( xRoot , "LeftLegCtrl"     );
		ATItemLock( xRoot , "LeftHandDir"     );
		ATItemLock( xRoot , "LeftHandDirEff"  );
		ATItemLock( xRoot , "LeftHandBaseEff"      );
		ATItemLock( xRoot , "LeftArmEndGoal" );
	}
	else {
		cColor[ 1 ] = 12 ;
		cColor[ 2 ] = 5 ;
		nSign = nType ;
		ATSchematic( xRoot , "RightArmGoal"    , xSchematicOrgItem ,  nSign*0.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightArmRot"     , xSchematicOrgItem ,  nSign*1.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightArmTipGoal" , xSchematicOrgItem ,  nSign*2.0 , -3.0 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightArmHandDirGoal" , xSchematicOrgItem ,  nSign*1.0 , -2.5 , cColor[ 2 ] );
		ATSchematic( xRoot , "RightArmEndGoal" , xSchematicOrgItem ,  nSign*0.0 , -2.5 , cColor[ 2 ] );

		ATSchematic( xRoot , "RightHandDir"    , xSchematicOrgItem ,  nSign*0.0 , -1.5 , cColor[ 2 ] );
		ATSchematic( xRoot , "RightHandDirEff" , xSchematicOrgItem ,  nSign*0.0 , -2.0 , cColor[ 2 ] );
		ATSchematic( xRoot , "RightHand"        , xSchematicOrgItem ,  nSign*1.0 , -1.5 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightHandBase"    , xSchematicOrgItem ,  nSign*2.0 , -1.5 , cColor[ 1 ] );
		ATSchematic( xRoot , "RightHandBaseEff" , xSchematicOrgItem ,  nSign*2.0 , -2.0 , cColor[ 2 ] );

		ATItemLock( xRoot , "RightArmHandDirGoal"      );
		ATItemLock( xRoot , "RighttHandDir"     );
		ATItemLock( xRoot , "RightHandDirEff"  );
		ATItemLock( xRoot , "RightHandBaseEff"      );
		ATItemLock( xRoot , "RightArmEndGoal" );
	}
}

BodySchematic : xRoot  , xModel , xHead
{
	xSchematicOrgItem = select_by_name( xRoot , "Hips" );
	ATSchematic( xRoot , "Hips"        , xModel ,  0.0 , 2.0  , 2 );
	ATSchematicAndBoneSetup( xRoot , "Spine"       , xSchematicOrgItem ,  0.0 , 1.0  , 1 , RotaionEnavbleOFF );
	ATSchematicAndBoneSetup( xRoot , "Spine1"      , xSchematicOrgItem ,  0.0 , 2.5  , 9 ,RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "Spine2"      , xSchematicOrgItem ,  0.0 , 4.0  , 9 ,RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "Spine3"      , xSchematicOrgItem ,  0.0 , 5.5  , 9 ,RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "NeckNull"    , xSchematicOrgItem ,  0.0 , 6.5  , 1  , RotaionEnavbleOFF);
	ATSchematicAndBoneSetup( xRoot , "Neck"        , xSchematicOrgItem ,  0.0 , 8.0  ,14 , RotaionEnavbleALL );
	if( xHead == null )
	{
		ATSchematicAndBoneSetup( xRoot , "Head"        , xSchematicOrgItem ,  0.0 , 8.5  ,14 , RotaionEnavbleALL );
	}
	else {
		ATSchematicAndBoneSetup( xRoot , "QuadHead"        , xSchematicOrgItem ,  0.0 , 8.5  ,14 , RotaionEnavbleALL );
		SelectItem( xHead.id ) ;
		sStr = "Rename Head" ;
		CommandInput( sStr ) ;	
	}
	ATItemLock( xRoot , "Spine" );
	ATItemLock( xRoot , "NeckNull" );


	ATSchematicAndBoneSetup( xRoot , "RootSpin"     , xSchematicOrgItem ,  0.0 ,-0.5  , 2 , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot , "LeftHip_a"    , xSchematicOrgItem ,  2.0 ,-0.5  , 3 , RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "LeftHip"      , xSchematicOrgItem ,  3.0 ,-4.0  , 10 , RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "RightHip_a"   , xSchematicOrgItem , -2.0 ,-0.5  , 5 , RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "RightHip"     , xSchematicOrgItem , -3.0 ,-4.0  , 12 , RotaionEnavbleALL);

	xSpine3 = select_by_name( xRoot , "Spine3" ); 
	ATSchematicAndBoneSetup( xRoot , "LeftShoulder_a"	, xSpine3 ,  1.5 , 2.0  , 3 , RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "LeftShoulderBase"	, xSpine3 ,  3.9 , 2.0  , 10 , RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "LeftShoulder"     , xSpine3 ,  4.0 , 1.5  , 10  , RotaionEnavbleALL);

	ATSchematicAndBoneSetup( xRoot , "RightShoulder_a"	, xSpine3 , -1.5 , 2.0  , 5 , RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "RightShoulderBase", xSpine3 , -3.9 , 2.0  , 12 , RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot , "RightShoulder"    , xSpine3 , -4.0 , 1.5  , 12 , RotaionEnavbleALL);

	xSchematicOrgItem = select_by_name( xRoot , "Head" );
	xRightEYE = select_by_name( xRoot , "RightEYE" );
	xLeftEYE = select_by_name( xRoot , "LeftEYE" );
	ATInplaceParent( xSchematicOrgItem , xRightEYE );	
	ATInplaceParent( xSchematicOrgItem , xLeftEYE );	

	ATSchematicAndBoneSetup( xRoot ,  "RightEYE" , xSchematicOrgItem , -1.0 , 0.5 , 12 , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "LeftEYE" , xSchematicOrgItem ,  1.0 , 0.5 , 10 , RotaionEnavbleALL );

}


Finger: xRoot , xLeftName , xRightName , dLArmStretch , dRArmStretch 
{
	xLeft = select_by_name( xRoot , xLeftName );
	xRight = select_by_name( xRoot , xRightName );

	xLeftHand = select_by_name( xRoot , "LeftHand" );
	xRightHand = select_by_name( xRoot , "RightHand" );

	xLeftDir = select_by_name( xRoot , "LeftHandDir" );
	xRightDir = select_by_name( xRoot ,"RightHandDir" );
	
	if( dLArmStretch <= 1.0 )
	{
		dLArmStretch = 1.0 ;
	}
	ATInplaceParent( xLeftHand.parent , xLeftDir );
	xLeftArm_IKFKBlendCtr = select_by_name( xRoot , "LeftArm_IKFKBlendCtr" );
	SelectItem( xLeftDir.id );
	CommandInput( "RotationItem " + hex( xLeftHand.id ) );
	CommandInput( "RotationItemWorld 1" );
	CommandInput( "HController 6" );
	CommandInput( "PController 6" );
	CommandInput( "BController 6" );
	CommandInput( "AddEnvelope Ctrl.RotItemBlend" );
	sExpName1 =   xLeftArm_IKFKBlendCtr.name + "_IKFKBlendHand" ;
	sExpression1 = "clamp([" + xLeftArm_IKFKBlendCtr.name+ ".Position.Z],0.000,1.000)" ;
	create_expression( sExpName1 , sExpression1 ) ;
	attach_expression( xRoot ,  xLeftDir.name , "Ctrl.RotItemBlend"  , sExpName1 );



	if( dRArmStretch <= 1.0 )
	{
		dRArmStretch = 1.0 ;
	}
	ATInplaceParent( xRightHand.parent , xRightDir );
	xRightArm_IKFKBlendCtr = select_by_name( xRoot , "RightArm_IKFKBlendCtr" );
	SelectItem( xRightDir.id );
	CommandInput( "RotationItem " + hex( xRightHand.id ) );
	CommandInput( "RotationItemWorld 1" );
	CommandInput( "HController 6" );
	CommandInput( "PController 6" );
	CommandInput( "BController 6" );
	CommandInput( "AddEnvelope Ctrl.RotItemBlend" );
	sExpName1 =   xRightArm_IKFKBlendCtr.name  + "_IKFKBlendHand" ;
	sExpression1 = "clamp([" + xRightArm_IKFKBlendCtr.name+ ".Position.Z],0.000,1.000)" ;
	create_expression( sExpName1 , sExpression1 ) ;
	attach_expression( xRoot ,  xRightDir.name , "Ctrl.RotItemBlend"  , sExpName1 );

	nSign = -1.0 ;
	cColor[ 1 ] = 12 ;
	cColor[ 2 ] = 5 ;

	ATSchematicAndBoneSetup( xRoot ,  "RightHandDir"    , xRight ,0.0 , -0.5 , cColor[ 2 ] , RotaionEnavbleALL );

	ATSchematicAndBoneSetup( xRoot ,  "RightHandThumb1" , xRightDir , nSign *-1.0 ,-0.8 , cColor[ 2 ] , RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot ,  "RightHandThumb2" , xRightDir , nSign *-1.0 ,-1.3 , cColor[ 1 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandThumb3" , xRightDir , nSign *-1.0 ,-1.8 , cColor[ 1 ] , RotaionEnavbleH );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandThumb4" , xRightDir , nSign *-1.0 ,-2.3 , cColor[ 1 ] , RotaionEnavbleH );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandIndex1" , xRightDir , nSign * 0.0 ,-1.4 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandIndex2" , xRightDir , nSign * 0.0 ,-1.9 , cColor[ 1 ] , RotaionEnavbleHP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandIndex3" , xRightDir , nSign * 0.0 ,-2.4 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandIndex4" , xRightDir , nSign * 0.0 ,-2.9 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandMiddle1", xRightDir , nSign * 1.0 ,-1.2 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandMiddle2", xRightDir , nSign * 1.0 ,-1.7 , cColor[ 1 ] , RotaionEnavbleHP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandMiddle3", xRightDir , nSign * 1.0 ,-2.2 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandMiddle4", xRightDir , nSign * 1.0 ,-2.7 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandRing1"  , xRightDir , nSign * 2.0 ,-1.0 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandRing2"  , xRightDir , nSign * 2.0 ,-1.5 , cColor[ 1 ] , RotaionEnavbleHP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandRing3"  , xRightDir , nSign * 2.0 ,-2.0 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandRing4"  , xRightDir , nSign * 2.0 ,-2.5 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandPinky1" , xRightDir , nSign * 3.0 ,-0.8 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandPinky2" , xRightDir , nSign * 3.0 ,-1.3 , cColor[ 1 ] , RotaionEnavbleHP);
	ATSchematicAndBoneSetup( xRoot ,  "RightHandPinky3" , xRightDir , nSign * 3.0 ,-1.8 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "RightHandPinky4" , xRightDir , nSign * 3.0 ,-2.3 , cColor[ 1 ] , RotaionEnavbleP );


	nSign = 1.0 ;
	cColor[ 1 ] = 10 ;
	cColor[ 2 ] = 3 ;

	ATSchematicAndBoneSetup( xRoot ,  "LeftHandDir" , xLeft , 0.0 , -0.5 , cColor[ 2 ] , RotaionEnavbleALL );

	ATSchematicAndBoneSetup( xRoot ,  "LeftHandThumb1" , xLeftDir  , nSign *-1.0 ,-0.8 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandThumb2" , xLeftDir  , nSign *-1.0 ,-1.3 , cColor[ 1 ] , 0RotaionEnavbleALL);
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandThumb3" , xLeftDir  , nSign *-1.0 ,-1.8 , cColor[ 1 ] , RotaionEnavbleH );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandThumb4" , xLeftDir  , nSign *-1.0 ,-2.3 , cColor[ 1 ] , RotaionEnavbleH );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandIndex1" , xLeftDir  , nSign * 0.0 ,-1.4 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandIndex2" , xLeftDir  , nSign * 0.0 ,-1.9 , cColor[ 1 ] , RotaionEnavbleHP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandIndex3" , xLeftDir  , nSign * 0.0 ,-2.4 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandIndex4" , xLeftDir  , nSign * 0.0 ,-2.9 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandMiddle1", xLeftDir  , nSign * 1.0 ,-1.2 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandMiddle2", xLeftDir  , nSign * 1.0 ,-1.7 , cColor[ 1 ] , RotaionEnavbleHP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandMiddle3", xLeftDir  , nSign * 1.0 ,-2.2 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandMiddle4", xLeftDir  , nSign * 1.0 ,-2.7 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandRing1"  , xLeftDir  , nSign * 2.0 ,-1.0 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandRing2"  , xLeftDir  , nSign * 2.0 ,-1.5 , cColor[ 1 ] , RotaionEnavbleHP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandRing3"  , xLeftDir  , nSign * 2.0 ,-2.0 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandRing4"  , xLeftDir  , nSign * 2.0 ,-2.5 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandPinky1" , xLeftDir  , nSign * 3.0 ,-0.8 , cColor[ 2 ] , RotaionEnavbleALL );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandPinky2" , xLeftDir  , nSign * 3.0 ,-1.3 , cColor[ 1 ] , RotaionEnavbleHP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandPinky3" , xLeftDir  , nSign * 3.0 ,-1.8 , cColor[ 1 ] , RotaionEnavbleP );
	ATSchematicAndBoneSetup( xRoot ,  "LeftHandPinky4" , xLeftDir  , nSign * 3.0 ,-2.3 , cColor[ 1 ] , RotaionEnavbleP );
}


GenerateTawasi: xRoot , nSubdivideNum , nUseWaightMap 
{

	xForeArm =  select_by_name( xRoot , "LeftForeArm" );
	xArm =  select_by_name( xRoot , "LeftArm" );
	GenerateDividBone( xRoot , xArm , nSubdivideNum , DIVIDE_BONE_TYPE_BOTTOM  , "LeftShoulder" , 10 , 4 , -2.5 , nUseWaightMap );
	GenerateDividBone( xRoot , xForeArm , nSubdivideNum , DIVIDE_BONE_TYPE_TOP , "LeftHand" , 10 , 4 , -2.5 , nUseWaightMap);

	UpdateMotion();	

	xForeArm =  select_by_name( xRoot , "RightForeArm" );
	xArm =  select_by_name( xRoot , "RightArm" );
	GenerateDividBone( xRoot , xArm , nSubdivideNum , DIVIDE_BONE_TYPE_BOTTOM , "RightShoulder" , 12 , 7 , 2.5 , nUseWaightMap);
	GenerateDividBone( xRoot , xForeArm , nSubdivideNum , DIVIDE_BONE_TYPE_TOP , "RightHand"  , 12 , 7 , 2.5 , nUseWaightMap);

	UpdateMotion();	

	xForeLeg =  select_by_name( xRoot , "LeftLeg" );
	xLeg =  select_by_name( xRoot , "LeftUpLeg" );
	GenerateDividBone( xRoot , xLeg , nSubdivideNum , DIVIDE_BONE_TYPE_BOTTOM , "LeftHip" , 10 , 4 , -2.0 , nUseWaightMap);
	GenerateDividBone( xRoot , xForeLeg , nSubdivideNum , DIVIDE_BONE_TYPE_TOP , "LeftAnkleEff" , 10 , 4 , -2.0 , nUseWaightMap);

	UpdateMotion();	

	xForeLeg =  select_by_name( xRoot , "RightLeg" );
	xLeg =  select_by_name( xRoot , "RightUpLeg" );
	GenerateDividBone( xRoot , xLeg , nSubdivideNum , DIVIDE_BONE_TYPE_BOTTOM ,"RightHip" ,  12 , 7 ,  2.0 , nUseWaightMap);
	GenerateDividBone( xRoot , xForeLeg , nSubdivideNum , DIVIDE_BONE_TYPE_TOP  ,"RightAnkleEff" ,  12 , 7 , 2.0 , nUseWaightMap);

	UpdateMotion();	
}

GenerateHiziHiza: xRoot , xQuadType 
{
	xBone =  select_by_name( xRoot , "LeftArm" );
	if( xQuadType )
	{
		xTargetBone =  select_by_name( xRoot , "LeftForeArm" );
		GenerateMidBone( xBone , xTargetBone , OFFSET_X_AXIS , -2.5 , -0.5  );
		xBone =  select_by_name( xRoot , "RightArm" );
		xTargetBone =  select_by_name( xRoot , "RightForeArm" );
		GenerateMidBone( xBone , xTargetBone , OFFSET_X_AXIS_MINUS   ,  2.5 , -0.5 );

		xBone =  select_by_name( xRoot , "LeftUpLeg" );
		xTargetBone =  select_by_name( xRoot , "LeftLeg" );
		GenerateMidBone( xBone , xTargetBone , OFFSET_X_AXIS_MINUS    , -2.0 ,  -1.0);
	
		xBone =  select_by_name( xRoot , "RightUpLeg" );
		xTargetBone =  select_by_name( xRoot , "RightLeg" );
		GenerateMidBone( xBone , xTargetBone , OFFSET_X_AXIS , 2.0 ,  -1.0 );

	}
	else {
		xTargetBone =  select_by_name( xRoot , "LeftForeArm" );
		GenerateMidBone( xBone , xTargetBone , OFFSET_Y_AXIS_MINUS , -2.5 , -0.5  );
		xBone =  select_by_name( xRoot , "RightArm" );
		xTargetBone =  select_by_name( xRoot , "RightForeArm" );
		GenerateMidBone( xBone , xTargetBone , OFFSET_Y_AXIS_MINUS ,  2.5 , -0.5 );

		xBone =  select_by_name( xRoot , "LeftUpLeg" );
		xTargetBone =  select_by_name( xRoot , "LeftLeg" );
		GenerateMidBone( xBone , xTargetBone , OFFSET_X_AXIS   , -2.0 ,  -1.0);

		xBone =  select_by_name( xRoot , "RightUpLeg" );
		xTargetBone =  select_by_name( xRoot , "RightLeg" );
		GenerateMidBone( xBone , xTargetBone , OFFSET_X_AXIS_MINUS  , 2.0 ,  -1.0 );
	}	
	
}

GenerateHeadGoal: xMaster , sHead 
{
	xHead = select_by_name( xMaster , sHead );
	if( xHead != null )
	{
		ATParentInPlace( PARENTINPLACE_OFF ) ;
		ATAddNull( "__Temp_HeadGoal" );
		ATParentAndRename( xHead ,"__Temp_HeadGoal"  , "HeadGoal" ) ;
		xHeadGoal =  select_by_name( xMaster , "HeadGoal" );
		AddPosition( 0.0 , 0.0 ,  xHead.restlength * 4 );
		s_fHeadMove = xHead.restlength;
		ATInplaceParent( xMaster ,  xHeadGoal ) ;
		ATSetCustomShape( xHeadGoal , 5 , 0.5 * xHead.restlength , 1 , xHead );
		// Targetting 
		SelectItem( xHead.id );
		TargetItem( xHeadGoal.id );
		HController(2);
		PController(2);
		BController(1);
		// Schematic
		ATSchematic( xMaster , "HeadGoal", xHead ,  -2.0 , 0.0 , 14 );
		
	}	
}

GenerateTail: xMaster , sIK , sIKStart , vStartRot , nUseWaightMap 
{
	var sTail = @"Tail_Null" ,"Tail_Start" ,"Tail_IK_IKBase","Tail_IK_IKNull" ,"Tail_a" ,"Tail_b","Tail_b","Tail_c"."Tail_d","Tail_IK"@;
	var sTailNoActive = @"Tail_Null","Tail_Start","Tail_IK_IKBase","Tail_IK_IKNull","Tail_IK" @;
	var sTailLock = @"Tail_Null","Tail_Start"@;


	sIKBaseBone = sIK + "_IKBase" ;
	sIKGoal = sIK + "_Goal" ;	
	sIKUPVector = sIK + "_UPVector" ;	
	xIKStrat = select_by_name( xMaster , sIKStart );
	xIKParent = xIKStrat.parent ;
	if( null != xIKParent )
	{
		if( null != ATIK_Start( xMaster , sIK , sIKStart ) )
		{
			ATIK_GenerateIKBaseBone( sIKBaseBone , xIKParent.name , vStartRot );
			ATIK_GenerateIKControlNULL( OFFSET_Y_AXIS , 1 );
			ATIK_IKControlSetting( xMaster , sIKGoal , sIKUPVector , AXIS_PITCH , 0.0 );
			ATIK_GenerateTargetBone( sIK + "_Target",  sIK + "_IKNull" , "TailBelndCtrl" );
			ATSchematic( xMaster , "Tail_Null"  , xMaster ,   5.0 , -2.0 , 4 );
			ATSchematic( xMaster , "Tail_Start"  , xMaster ,  5.0 , -1.5 , 4 );
			BonesSetup( xMaster , sTail ,  sTailNoActive , sTailLock , nUseWaightMap );
			ATIK_Schematic( "Tail_Start" , 10 , 3  , ATIK_SCHEMATIC_PLUS );
			ATIK_End() ;
		}
		UpdateMotion();	
	}
}
//--------------------- YURE-----------------
// Null Bone Setup 
null_bone_setup: xParent , xRoot 
{
	s_xSearchItem = nil ;
	null_bone_setup_searchItem( xParent , xRoot ) ;
	return s_xSearchItem ;
}

null_bone_setup_searchItem: xParent ,xItem 
{
	time = 0 ;
	xMesh = xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( xMesh.genus == BONE )
		{
			xPre = strright( xName[ 1 ] , 5 ) ;
			if( xPre != nil )
			{
				if( xPre == "_Null" )
				{
					SelectItem( xMesh.id );
					CommandInput( "ItemVisibility 0" ) ;
					if( xMesh.flags[ 1 ] == true )
					{
						CommandInput( "BoneActive" );
					}
				}
			}
			
			xPre = strright( xName[ 1 ] , 3 ) ;
			xPre2 = strright( xName[ 1 ] , 7 ) ;
			if( xPre != nil )
			{
				if( xPre == "_IK" || xPre2 == "_Muscle" )
				{
					SelectItem( xMesh.id );

					CommandInput( "ItemVisibility 0" ) ;
					if( xMesh.flags[ 1 ] == true )
					{
						CommandInput( "BoneActive" );
					}

					// AccCtrl NULL
					xNullName = "___TEMP__" + xName[ 1 ] + "Ctrl" ;

					str = "AddNull " + xNullName  ;
					CommandInput( str );
					xItemNull = Mesh( xNullName );
					SelectItem( xItemNull.id );
					
					sStr = "Rename "  +  xName[ 1 ] + "Ctrl" ;
					CommandInput( sStr ) ;					
						
					ParentItem( xParent.id );
					vPos = xMesh.getWorldPosition( time );
					createKeys( xItemNull , vPos , nil , nil , time  );
					// FullTimeIK
					SelectItem( xMesh.id );
					str = "GoalItem " + hex( xItemNull.id ) ;
					CommandInput( str );
					// fulltime_ik() ; default fulltime IK ON 
					null_bone_set_ik_sts( xMesh.parent );

				
				}
			}			
		}
		null_bone_setup_searchItem( xParent , xMesh );
		xMesh = xItem.nextChild();
	}
}
null_bone_set_ik_sts: xMesh 
{
	xParent = xMesh ;
	if( xMesh.genus != BONE )
	{
		return ;
	}
	if( nil != xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		xPre = strright( xName[ 1 ] , 5 ) ;
		if( xPre != nil )
		{
			if( xPre == "_Null" )
			{
				return ;
			}
		}	
			
		xPre = strright( xName[ 1 ] , 6 ) ;
		if( xPre != nil )
		{
			if( xPre == "_Start" )
			{
				SelectItem( xMesh.id );
				if( xMesh.flags[ 1 ] == true )
				{
					CommandInput( "BoneActive" );
				}
				CommandInput( "UnaffectedByIK" ); 
				return ;
			}
		}
		SelectItem( xMesh.id );
		vStartRot = <0 ,0 , 0 > ;
		CommandInput( "RecordPivotRotation" );
		CommandInput( "RecordRestPosition" );
		createKeys( xMesh , nil , vStartRot , nil , 0 );		
		CommandInput( "HController 3" );
		CommandInput( "PController 3" );
		CommandInput( "EnableXH" );
		CommandInput( "EnableYP" );
		CommandInput( "EnableZB" );
		xPre = strright( xName[ 1 ] , 7 ) ;
		//if( xPre == "_Muscle" )
		//{
		//	CommandInput( "ApplyServer ItemMotionHandler ATMuscle" );
		//}
		//CommandInput( "RefreshNow" );
		
		null_bone_set_ik_sts( xMesh.parent );
	}
	return ;
}
